uniform sampler2D u_normal_map;
uniform samplerCube u_environment_map;

varying vec3 v_tangent;
varying vec3 v_bitangent;
varying vec3 v_normal;

varying vec3 v_view;

vec3 get_normal()
{
	// renormalize basis vectors just in case 
	// interpolation distorts them
	vec3 t = normalize(v_tangent);
	vec3 b = normalize(v_bitangent);
	vec3 n = normalize(v_normal);
	
	vec3 s = texture2D(u_normal_map, gl_TexCoord[0].xy).xyz * 2.0 - 1.0;
	return t * s.x + b * s.y + n * s.z;
}

void main()
{
	gl_FragColor = textureCube(u_environment_map, reflect(v_view, get_normal()));
}
