#version 110

varying vec3 v_tangent;
varying vec3 v_bitangent;
varying vec3 v_normal;

// view vector from vertex to eye
varying vec3 v_view;

void main()
{
	gl_Position = ftransform();
	gl_TexCoord[0] = gl_MultiTexCoord0;
	
	// compute tbn matrix vectors
	v_normal = gl_Normal;	
	v_tangent = gl_MultiTexCoord1.xyz;
	v_bitangent = cross(v_normal, v_tangent) * gl_MultiTexCoord1.w;
	
	// compute view vector
	vec4 t = gl_ModelViewMatrixInverse[3];
	vec3 eye_position = t.xyz / t.w;
	
	v_view = (gl_Vertex.xyz / gl_Vertex.w) - eye_position;
}
