#version 120
#extension GL_3DL_array_objects : enable

uniform sampler2D u_texture;
uniform vec2 u_pixel_size;

// kawase bloom filter sample positions to be 
// used with bilinearly filtered texture
vec2 samplepos[4] = vec2[4](
	vec2(-0.5,  0.5),
	vec2(-0.5, -0.5),
	vec2( 0.5, -0.5),
	vec2( 0.5,  0.5)
);
	
void main()
{
	gl_FragColor = vec4(0.0);
	for (int i = 0; i < 4; ++i)
		gl_FragColor += texture2D(u_texture, gl_TexCoord[0].xy + samplepos[i] * u_pixel_size);
	gl_FragColor /= 4.0;
}
