uniform sampler2D u_ssao_tex;

varying float v_light;

void main()
{
	// do projective texture sampling
	vec4 c = texture2D(u_ssao_tex, (gl_TexCoord[0].xy / gl_TexCoord[0].w) * 0.5 + 0.5);
	
	// multiply the ssao texture fetch result by 2 and 
	// clamp since flat surfaces have a value of 0.5
	c = min(c * 2.0, 1.0);
	
	// ambient + diffuse
	gl_FragColor = vec4(c * 0.4 + v_light);
}
