#version 110

uniform vec2 u_tile_count;

varying vec3 v_view_ray;
varying vec2 v_tex_coord;
varying vec2 v_noise_coord;

void main()
{
	gl_Position = vec4(gl_Vertex.xy, 0.0, 1.0);
	v_tex_coord = gl_Vertex.xy * 0.5 + 0.5;
	
	// compute view ray though the vertex
	vec4 v = gl_ProjectionMatrixInverse * vec4(gl_Vertex.xy, 1.0, 1.0);
	v_view_ray = v.xyz / v.w;
	
	v_noise_coord = v_tex_coord * u_tile_count;
}
